<template>
    <i-form :model="this.data" class='app-form' ref='form'  id='form' style="">
    <input style="display:none;" />
    <row >
            
<i-col v-show="detailsModel.grouppanel2.visible" :style="{}"  :lg="{ span: 24, offset: 0 }">
    <app-form-group layoutType="TABLE_24COL" titleStyle="" class='' uiActionGroup="detailsModel.grouppanel2.uiActionGroup" @groupuiactionclick="groupUIActionClick($event)" :caption="$t('entities.emequip.main4_form.details.grouppanel2')" :isShowCaption="false" uiStyle="DEFAULT" :titleBarCloseMode="1" :isInfoGroupMode="false" >    
    <row>
        <i-col v-show="detailsModel.equipcode.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='equipcode' :itemRules="this.rules.equipcode" class='' :caption="$t('entities.emequip.main4_form.details.equipcode')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.equipcode.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.equipcode"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.equipcode.disabled" type='text'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.emequipname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='emequipname' :itemRules="this.rules.emequipname" class='' :caption="$t('entities.emequip.main4_form.details.emequipname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.emequipname.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.emequipname"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.emequipname.disabled" type='text'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.equippname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='equippname' :itemRules="this.rules.equippname" class='' :caption="$t('entities.emequip.main4_form.details.equippname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.equippname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-picker 
  :formState="formState"
  :data="data"
  :context="context"
  :viewparams="viewparams"
  :itemParam='{ }' 
  :disabled="detailsModel.equippname.disabled"
  name='equippname'
  deMajorField='emequipname'
  deKeyField='emequip'
  :service="service"
  :acParams="{ serviceName: 'EMEquipService', interfaceName: 'FetchDefault'}"
  valueitem='equippid' 
  :value="data.equippname" 
  editortype="" 
  :pickupView="{ viewname: 'emequippickup-view', title: $t('entities.emequip.views.pickupview.title'), deResParameters: [{ pathName: 'emeqtypes', parameterName: 'emeqtype' }, ], parameters: [{ pathName: 'emequips', parameterName: 'emequip' }, { pathName: 'pickupview', parameterName: 'pickupview' } ], placement:'' }"
  style=""  
  @formitemvaluechange="onFormItemValueChange">
</app-picker>

</app-form-item>

</i-col>
<i-col v-show="detailsModel.eqtypename.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='eqtypename' :itemRules="this.rules.eqtypename" class='' :caption="$t('entities.emequip.main4_form.details.eqtypename')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.eqtypename.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-picker 
  :formState="formState"
  :data="data"
  :context="context"
  :viewparams="viewparams"
  :itemParam='{ }' 
  :disabled="detailsModel.eqtypename.disabled"
  name='eqtypename'
  deMajorField='emeqtypename'
  deKeyField='emeqtype'
  :service="service"
  :acParams="{ serviceName: 'EMEQTypeService', interfaceName: 'FetchDefault'}"
  valueitem='eqtypeid' 
  :value="data.eqtypename" 
  editortype="" 
  :pickupView="{ viewname: 'emeqtypepickup-view', title: $t('entities.emeqtype.views.pickupview.title'), deResParameters: [], parameters: [{ pathName: 'emeqtypes', parameterName: 'emeqtype' }, { pathName: 'pickupview', parameterName: 'pickupview' } ], placement:'' }"
  style=""  
  @formitemvaluechange="onFormItemValueChange">
</app-picker>

</app-form-item>

</i-col>
<i-col v-show="detailsModel.eqlocationname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='eqlocationname' :itemRules="this.rules.eqlocationname" class='' :caption="$t('entities.emequip.main4_form.details.eqlocationname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.eqlocationname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-picker 
  :formState="formState"
  :data="data"
  :context="context"
  :viewparams="viewparams"
  :itemParam='{ }' 
  :disabled="detailsModel.eqlocationname.disabled"
  name='eqlocationname'
  deMajorField='emeqlocationname'
  deKeyField='emeqlocation'
  :service="service"
  :acParams="{ serviceName: 'EMEQLocationService', interfaceName: 'FetchDefault'}"
  valueitem='eqlocationid' 
  :value="data.eqlocationname" 
  editortype="" 
  :pickupView="{ viewname: 'emeqlocationpickup-view', title: $t('entities.emeqlocation.views.pickupview.title'), deResParameters: [], parameters: [{ pathName: 'emeqlocations', parameterName: 'emeqlocation' }, { pathName: 'pickupview', parameterName: 'pickupview' } ], placement:'' }"
  style=""  
  @formitemvaluechange="onFormItemValueChange">
</app-picker>

</app-form-item>

</i-col>
<i-col v-show="detailsModel.deptname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='deptname' :itemRules="this.rules.deptname" class='' :caption="$t('entities.emequip.main4_form.details.deptname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.deptname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-picker 
  :formState="formState"
  :data="data"
  :context="context"
  :viewparams="viewparams"
  :itemParam='{ }' 
  :disabled="detailsModel.deptname.disabled"
  name='deptname'
  deMajorField='pfdeptname'
  deKeyField='pfdept'
  :service="service"
  :acParams="{ serviceName: 'PFDeptService', interfaceName: 'FetchDefault'}"
  valueitem='deptid' 
  :value="data.deptname" 
  editortype="" 
  :pickupView="{ viewname: 'pfdeptpickup-view', title: $t('entities.pfdept.views.pickupview.title'), deResParameters: [], parameters: [{ pathName: 'pfdepts', parameterName: 'pfdept' }, { pathName: 'pickupview', parameterName: 'pickupview' } ], placement:'' }"
  style=""  
  @formitemvaluechange="onFormItemValueChange">
</app-picker>

</app-form-item>

</i-col>
<i-col v-show="detailsModel.empname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='empname' :itemRules="this.rules.empname" class='' :caption="$t('entities.emequip.main4_form.details.empname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.empname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-picker 
  :formState="formState"
  :data="data"
  :context="context"
  :viewparams="viewparams"
  :itemParam='{ }' 
  :disabled="detailsModel.empname.disabled"
  name='empname'
  deMajorField='pfempname'
  deKeyField='pfemp'
  :service="service"
  :acParams="{ serviceName: 'PFEmpService', interfaceName: 'FetchDefault'}"
  valueitem='empid' 
  :value="data.empname" 
  editortype="" 
  :pickupView="{ viewname: 'pfemppickup-view', title: $t('entities.pfemp.views.pickupview.title'), deResParameters: [], parameters: [{ pathName: 'pfemps', parameterName: 'pfemp' }, { pathName: 'pickupview', parameterName: 'pickupview' } ], placement:'' }"
  style=""  
  @formitemvaluechange="onFormItemValueChange">
</app-picker>

</app-form-item>

</i-col>
<i-col v-show="detailsModel.rteamname.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='rteamname' :itemRules="this.rules.rteamname" class='' :caption="$t('entities.emequip.main4_form.details.rteamname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.rteamname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-picker 
  :formState="formState"
  :data="data"
  :context="context"
  :viewparams="viewparams"
  :itemParam='{ }' 
  :disabled="detailsModel.rteamname.disabled"
  name='rteamname'
  deMajorField='pfteamname'
  deKeyField='pfteam'
  :service="service"
  :acParams="{ serviceName: 'PFTeamService', interfaceName: 'FetchDefault'}"
  valueitem='rteamid' 
  :value="data.rteamname" 
  editortype="" 
  :pickupView="{ viewname: 'pfteampickup-view', title: $t('entities.pfteam.views.pickupview.title'), deResParameters: [], parameters: [{ pathName: 'pfteams', parameterName: 'pfteam' }, { pathName: 'pickupview', parameterName: 'pickupview' } ], placement:'' }"
  style=""  
  @formitemvaluechange="onFormItemValueChange">
</app-picker>

</app-form-item>

</i-col>
<i-col v-show="detailsModel.equipgroup.visible" :style="{}"  :lg="{ span: 24, offset: 0 }" :xl="{ span: 24, offset: 0 }">
    <app-form-item name='equipgroup' :itemRules="this.rules.equipgroup" class='' :caption="$t('entities.emequip.main4_form.details.equipgroup')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.equipgroup.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-checkbox-list v-model="data.equipgroup" :disabled="detailsModel.equipgroup.disabled"  tag='EMEQUIPGROUP' codelistType='STATIC'   mode="num" name="equipgroup" style=""></app-checkbox-list>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.params.visible" :style="{}"  :lg="{ span: 23, offset: 1 }" :xl="{ span: 23, offset: 1 }">
    <app-form-item name='params' :itemRules="this.rules.params" class='' :caption="$t('entities.emequip.main4_form.details.params')" uiStyle="DEFAULT" :labelWidth="0" :isShowCaption="false" :error="detailsModel.params.error" :isEmptyCaption="false" labelPos="NONE">
    <app-rich-text-editor :formState="formState" :value="data.params" @change="(val) =>{this.data.params =val}" :disabled="detailsModel.params.disabled"  name="params" style=""></app-rich-text-editor>
</app-form-item>

</i-col>
    
    </row>
</app-form-group>

</i-col>
<i-col v-show="detailsModel.grouppanel13.visible" :style="{}"  :lg="{ span: 24, offset: 0 }">
    <app-form-group layoutType="TABLE_24COL" titleStyle="" class='' uiActionGroup="detailsModel.grouppanel13.uiActionGroup" @groupuiactionclick="groupUIActionClick($event)" :caption="$t('entities.emequip.main4_form.details.grouppanel13')" :isShowCaption="true" uiStyle="DEFAULT" :titleBarCloseMode="1" :isInfoGroupMode="false" >    
    <row>
        <i-col v-show="detailsModel.eqstate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='eqstate' :itemRules="this.rules.eqstate" class='' :caption="$t('entities.emequip.main4_form.details.eqstate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.eqstate.error" :isEmptyCaption="false" labelPos="LEFT">
     <dropdown-list v-model="data.eqstate" :data="data" :itemParam="{}" :disabled="detailsModel.eqstate.disabled"  tag='EMEQUIPSTATE' codelistType='STATIC' placeholder='请选择...' style=""></dropdown-list>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.eqisservice.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='eqisservice' :itemRules="this.rules.eqisservice" class='' :caption="$t('entities.emequip.main4_form.details.eqisservice')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.eqisservice.error" :isEmptyCaption="false" labelPos="LEFT">
     <dropdown-list v-model="data.eqisservice" :data="data" :itemParam="{}" :disabled="detailsModel.eqisservice.disabled" style="width:100px;width: 100px;" tag='YesNo' codelistType='STATIC'  placeholder='请选择...'></dropdown-list>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.eqstartdate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='eqstartdate' :itemRules="this.rules.eqstartdate" class='' :caption="$t('entities.emequip.main4_form.details.eqstartdate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.eqstartdate.error" :isEmptyCaption="false" labelPos="LEFT">
    <date-picker type="date" :transfer="true" format="yyyy-MM-dd" placeholder="请选择时间..." :value="data.eqstartdate" :disabled="detailsModel.eqstartdate.disabled" style="min-width: 150px; width:100px;" @on-change="(val1, val2) => { this.data.eqstartdate = val1 }"></date-picker>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.eqsumstoptime.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='eqsumstoptime' :itemRules="this.rules.eqsumstoptime" class='' :caption="$t('entities.emequip.main4_form.details.eqsumstoptime')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.eqsumstoptime.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.eqsumstoptime"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.eqsumstoptime.disabled" type='number'  style=""></input-box>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.grouppanel18.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-group layoutType="TABLE_24COL" titleStyle="" class='' uiActionGroup="detailsModel.grouppanel18.uiActionGroup" @groupuiactionclick="groupUIActionClick($event)" :caption="$t('entities.emequip.main4_form.details.grouppanel18')" :isShowCaption="false" uiStyle="DEFAULT" :titleBarCloseMode="0" :isInfoGroupMode="false" >    
    <row>
        <i-col v-show="detailsModel.haltstate.visible" :style="{}"  :lg="{ span: 24, offset: 0 }" :xl="{ span: 24, offset: 0 }">
    <app-form-item name='haltstate' :itemRules="this.rules.haltstate" class='' :caption="$t('entities.emequip.main4_form.details.haltstate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.haltstate.error" :isEmptyCaption="false" labelPos="LEFT">
     <dropdown-list v-model="data.haltstate" :data="data" :itemParam="{}" :disabled="detailsModel.haltstate.disabled"  tag='HALTTYPE' codelistType='STATIC' placeholder='请选择...' style=""></dropdown-list>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.haltcause.visible" :style="{}"  :lg="{ span: 24, offset: 0 }" :xl="{ span: 24, offset: 0 }">
    <app-form-item name='haltcause' :itemRules="this.rules.haltcause" class='' :caption="$t('entities.emequip.main4_form.details.haltcause')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.haltcause.error" :isEmptyCaption="false" labelPos="LEFT">
    <input-box v-model="data.haltcause"  @enter="onEnter($event)"   unit=""  :disabled="detailsModel.haltcause.disabled" type='text'  style=""></input-box>
</app-form-item>

</i-col>
    
    </row>
</app-form-group>

</i-col>
    
    </row>
</app-form-group>

</i-col>


    </row>
</i-form>
</template>

<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch, Model } from 'vue-property-decorator';
import { CreateElement } from 'vue';
import { Subject, Subscription } from 'rxjs';
import { ControlInterface } from '@/interface/control';
import { UIActionTool,Util } from '@/utils';
import EMEquipService from '@/service/emequip/emequip-service';
import Main4Service from './main4-form-service';

import { FormButtonModel, FormPageModel, FormItemModel, FormDRUIPartModel, FormPartModel, FormGroupPanelModel, FormIFrameModel, FormRowItemModel, FormTabPageModel, FormTabPanelModel, FormUserControlModel } from '@/model/form-detail';
import { debounceTime, distinctUntilChanged } from 'rxjs/operators';


@Component({
    components: {
      
    }
})
export default class Main4Base extends Vue implements ControlInterface {

    /**
     * 名称
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public name?: string;

    /**
     * 视图通讯对象
     *
     * @type {Subject<ViewState>}
     * @memberof Main4
     */
    @Prop() public viewState!: Subject<ViewState>;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof Main4
     */
    @Prop() public context: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof Main4
     */
    @Prop() public viewparams: any;

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof Main4
     */
    public viewStateEvent: Subscription | undefined;

    /**
     * 获取部件类型
     *
     * @returns {string}
     * @memberof Main4
     */
    public getControlType(): string {
        return 'FORM'
    }



    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof Main4
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 建构部件服务对象
     *
     * @type {Main4Service}
     * @memberof Main4
     */
    public service: Main4Service = new Main4Service({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {EMEquipService}
     * @memberof Main4
     */
    public appEntityService: EMEquipService = new EMEquipService({ $store: this.$store });
    


    /**
     * 关闭视图
     *
     * @param {any} args
     * @memberof Main4
     */
    public closeView(args: any): void {
        let _this: any = this;
        _this.$emit('closeview', [args]);
    }

    /**
     *  计数器刷新
     *
     * @memberof Main4
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }


    
    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof Main4
     */
    public getDatas(): any[] {
        return [this.data];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof Main4
     */
    public getData(): any {
        return this.data;
    }

    /**
     * 是否默认保存
     *
     * @type {boolean}
     * @memberof Main4
     */
    @Prop({ default: false }) public autosave?: boolean;

    /**
     * 显示处理提示
     *
     * @type {boolean}
     * @memberof Main4
     */
    @Prop({ default: true }) public showBusyIndicator?: boolean;

    /**
     * 部件行为--submit
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public WFSubmitAction!: string;
    
    /**
     * 部件行为--start
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public WFStartAction!: string;
    
    /**
     * 部件行为--update
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public updateAction!: string;
    
    /**
     * 部件行为--remove
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public removeAction!: string;
    
    /**
     * 部件行为--loaddraft
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public loaddraftAction!: string;
    
    /**
     * 部件行为--load
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public loadAction!: string;
    
    /**
     * 部件行为--create
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public createAction!: string;

    /**
     * 部件行为--create
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public searchAction!: string;

    /**
     * 视图标识
     *
     * @type {string}
     * @memberof Main4
     */
    @Prop() public viewtag!: string;

    /**
     * 表单状态
     *
     * @type {Subject<any>}
     * @memberof Main4
     */
    public formState: Subject<any> = new Subject();

    /**
     * 忽略表单项值变化
     *
     * @type {boolean}
     * @memberof Main4
     */
    public ignorefieldvaluechange: boolean = false;

    /**
     * 数据变化
     *
     * @public
     * @type {Subject<any>}
     * @memberof Main4
     */
    public dataChang: Subject<any> = new Subject();

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof Main4
     */
    public dataChangEvent: Subscription | undefined;

    /**
     * 原始数据
     *
     * @public
     * @type {*}
     * @memberof Main4
     */
    public oldData: any = {};

    /**
     * 表单数据对象
     *
     * @type {*}
     * @memberof Main4
     */
    public data: any = {
        srfupdatedate: null,
        srforikey: null,
        srfkey: null,
        srfmajortext: null,
        srftempmode: null,
        srfuf: null,
        srfdeid: null,
        srfsourcekey: null,
        equipcode: null,
        emequipname: null,
        equippname: null,
        eqtypename: null,
        eqlocationname: null,
        deptname: null,
        empname: null,
        rteamname: null,
        equipgroup: null,
        params: null,
        eqstate: null,
        eqisservice: null,
        eqstartdate: null,
        eqsumstoptime: null,
        haltstate: null,
        haltcause: null,
        empid: null,
        deptid: null,
        eqlocationid: null,
        emequipid: null,
        equippid: null,
        rteamid: null,
        eqtypeid: null,
        emequip:null,
    };

    /**
      * 当前执行的行为逻辑
      *
      * @type {string}
      * @memberof Main4
      */
    public currentAction: string = "";

    /**
      * 关系界面计数器
      *
      * @type {number}
      * @memberof Main4
      */
    public drcounter: number = 0;

    /**
      * 需要等待关系界面保存时，第一次调用save参数的备份
      *
      * @type {number}
      * @memberof Main4
      */
    public drsaveopt: any = {};

    /**
      * 表单保存回调存储对象
      *
      * @type {any}
      * @memberof Main4
      */
    public saveState:any ;

    /**
     * 属性值规则
     *
     * @type {*}
     * @memberof Main4
     */
    public rules: any = {
        srfupdatedate: [
            { type: 'string', message: '更新时间 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '更新时间 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '更新时间 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '更新时间 值不能为空', trigger: 'blur' },
        ],
        srforikey: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfkey: [
            { type: 'string', message: '设备标识 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '设备标识 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '设备标识 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '设备标识 值不能为空', trigger: 'blur' },
        ],
        srfmajortext: [
            { type: 'string', message: '设备名称 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '设备名称 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '设备名称 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '设备名称 值不能为空', trigger: 'blur' },
        ],
        srftempmode: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfuf: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfdeid: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfsourcekey: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        equipcode: [
            { type: 'string', message: '设备代码 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '设备代码 值必须为字符串类型', trigger: 'blur' },
            { required: true, type: 'string', message: '设备代码 值不能为空', trigger: 'change' },
            { required: true, type: 'string', message: '设备代码 值不能为空', trigger: 'blur' },
        ],
        emequipname: [
            { type: 'string', message: '设备名称 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '设备名称 值必须为字符串类型', trigger: 'blur' },
            { required: true, type: 'string', message: '设备名称 值不能为空', trigger: 'change' },
            { required: true, type: 'string', message: '设备名称 值不能为空', trigger: 'blur' },
        ],
        equippname: [
            { type: 'string', message: '上级设备 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '上级设备 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '上级设备 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '上级设备 值不能为空', trigger: 'blur' },
        ],
        eqtypename: [
            { type: 'string', message: '设备类型 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '设备类型 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '设备类型 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '设备类型 值不能为空', trigger: 'blur' },
        ],
        eqlocationname: [
            { type: 'string', message: '位置 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '位置 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '位置 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '位置 值不能为空', trigger: 'blur' },
        ],
        deptname: [
            { type: 'string', message: '专责部门 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '专责部门 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '专责部门 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '专责部门 值不能为空', trigger: 'blur' },
        ],
        empname: [
            { type: 'string', message: '专责人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '专责人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '专责人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '专责人 值不能为空', trigger: 'blur' },
        ],
        rteamname: [
            { type: 'string', message: '责任班组 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '责任班组 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '责任班组 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '责任班组 值不能为空', trigger: 'blur' },
        ],
        equipgroup: [
            { type: 'number', message: '设备分组 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '设备分组 值必须为数值类型', trigger: 'blur' },
            { required: true, type: 'number', message: '设备分组 值不能为空', trigger: 'change' },
            { required: true, type: 'number', message: '设备分组 值不能为空', trigger: 'blur' },
        ],
        params: [
            { type: 'string', message: '基本参数 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '基本参数 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '基本参数 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '基本参数 值不能为空', trigger: 'blur' },
        ],
        eqstate: [
            { type: 'string', message: '设备状态 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '设备状态 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '设备状态 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '设备状态 值不能为空', trigger: 'blur' },
        ],
        eqisservice: [
            { type: 'number', message: '设备是否在工作 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '设备是否在工作 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '设备是否在工作 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '设备是否在工作 值不能为空', trigger: 'blur' },
        ],
        eqstartdate: [
            { type: 'string', message: '投运日期 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '投运日期 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '投运日期 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '投运日期 值不能为空', trigger: 'blur' },
        ],
        eqsumstoptime: [
            { type: 'number', message: '总停机时间 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '总停机时间 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '总停机时间 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '总停机时间 值不能为空', trigger: 'blur' },
        ],
        haltstate: [
            { type: 'string', message: '停机类型 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '停机类型 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '停机类型 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '停机类型 值不能为空', trigger: 'blur' },
        ],
        haltcause: [
            { type: 'string', message: '停机原因 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '停机原因 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '停机原因 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '停机原因 值不能为空', trigger: 'blur' },
        ],
        empid: [
            { type: 'string', message: '专责人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '专责人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '专责人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '专责人 值不能为空', trigger: 'blur' },
        ],
        deptid: [
            { type: 'string', message: '专责部门 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '专责部门 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '专责部门 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '专责部门 值不能为空', trigger: 'blur' },
        ],
        eqlocationid: [
            { type: 'string', message: '位置 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '位置 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '位置 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '位置 值不能为空', trigger: 'blur' },
        ],
        emequipid: [
            { type: 'string', message: '设备标识 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '设备标识 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '设备标识 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '设备标识 值不能为空', trigger: 'blur' },
        ],
        equippid: [
            { type: 'string', message: '上级设备 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '上级设备 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '上级设备 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '上级设备 值不能为空', trigger: 'blur' },
        ],
        rteamid: [
            { type: 'string', message: '责任班组 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '责任班组 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '责任班组 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '责任班组 值不能为空', trigger: 'blur' },
        ],
        eqtypeid: [
            { type: 'string', message: '设备类型 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '设备类型 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '设备类型 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '设备类型 值不能为空', trigger: 'blur' },
        ],
    }

    /**
     * 详情模型集合
     *
     * @type {*}
     * @memberof Main4
     */
    public detailsModel: any = {
        grouppanel2: new FormGroupPanelModel({ caption: '基本信息', detailType: 'GROUPPANEL', name: 'grouppanel2', visible: true, isShowCaption: false, form: this, uiActionGroup: { caption: '', langbase: 'entities.emequip.main4_form', extractMode: 'ITEM', details: [] } })
, 
        grouppanel18: new FormGroupPanelModel({ caption: '分组', detailType: 'GROUPPANEL', name: 'grouppanel18', visible: true, isShowCaption: false, form: this, uiActionGroup: { caption: '', langbase: 'entities.emequip.main4_form', extractMode: 'ITEM', details: [] } })
, 
        grouppanel13: new FormGroupPanelModel({ caption: '运行信息', detailType: 'GROUPPANEL', name: 'grouppanel13', visible: true, isShowCaption: true, form: this, uiActionGroup: { caption: '', langbase: 'entities.emequip.main4_form', extractMode: 'ITEM', details: [] } })
, 
        formpage1: new FormPageModel({ caption: '基本信息', detailType: 'FORMPAGE', name: 'formpage1', visible: true, isShowCaption: true, form: this })
, 
        srfupdatedate: new FormItemModel({ caption: '更新时间', detailType: 'FORMITEM', name: 'srfupdatedate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        srforikey: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srforikey', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfkey: new FormItemModel({ caption: '设备标识', detailType: 'FORMITEM', name: 'srfkey', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        srfmajortext: new FormItemModel({ caption: '设备名称', detailType: 'FORMITEM', name: 'srfmajortext', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srftempmode: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srftempmode', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfuf: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srfuf', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfdeid: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srfdeid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfsourcekey: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srfsourcekey', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        equipcode: new FormItemModel({ caption: '设备代码', detailType: 'FORMITEM', name: 'equipcode', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 1 })
, 
        emequipname: new FormItemModel({ caption: '设备名称', detailType: 'FORMITEM', name: 'emequipname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        equippname: new FormItemModel({ caption: '上级设备', detailType: 'FORMITEM', name: 'equippname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        eqtypename: new FormItemModel({ caption: '设备类型', detailType: 'FORMITEM', name: 'eqtypename', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        eqlocationname: new FormItemModel({ caption: '位置', detailType: 'FORMITEM', name: 'eqlocationname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        deptname: new FormItemModel({ caption: '专责部门', detailType: 'FORMITEM', name: 'deptname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        empname: new FormItemModel({ caption: '专责人', detailType: 'FORMITEM', name: 'empname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        rteamname: new FormItemModel({ caption: '责任班组', detailType: 'FORMITEM', name: 'rteamname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        equipgroup: new FormItemModel({ caption: '设备分组', detailType: 'FORMITEM', name: 'equipgroup', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        params: new FormItemModel({ caption: '基本参数', detailType: 'FORMITEM', name: 'params', visible: true, isShowCaption: false, form: this, disabled: false, enableCond: 3 })
, 
        eqstate: new FormItemModel({ caption: '设备状态', detailType: 'FORMITEM', name: 'eqstate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        eqisservice: new FormItemModel({ caption: '设备是否在工作', detailType: 'FORMITEM', name: 'eqisservice', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        eqstartdate: new FormItemModel({ caption: '投运日期', detailType: 'FORMITEM', name: 'eqstartdate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        eqsumstoptime: new FormItemModel({ caption: '总停机时间', detailType: 'FORMITEM', name: 'eqsumstoptime', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        haltstate: new FormItemModel({ caption: '停机类型', detailType: 'FORMITEM', name: 'haltstate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        haltcause: new FormItemModel({ caption: '停机原因', detailType: 'FORMITEM', name: 'haltcause', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        empid: new FormItemModel({ caption: '专责人', detailType: 'FORMITEM', name: 'empid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        deptid: new FormItemModel({ caption: '专责部门', detailType: 'FORMITEM', name: 'deptid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        eqlocationid: new FormItemModel({ caption: '位置', detailType: 'FORMITEM', name: 'eqlocationid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        emequipid: new FormItemModel({ caption: '设备标识', detailType: 'FORMITEM', name: 'emequipid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        equippid: new FormItemModel({ caption: '上级设备', detailType: 'FORMITEM', name: 'equippid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        rteamid: new FormItemModel({ caption: '责任班组', detailType: 'FORMITEM', name: 'rteamid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        eqtypeid: new FormItemModel({ caption: '设备类型', detailType: 'FORMITEM', name: 'eqtypeid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
    };

    /**
     * 监控表单属性 srfupdatedate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.srfupdatedate')
    onSrfupdatedateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfupdatedate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srforikey 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.srforikey')
    onSrforikeyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srforikey', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfkey 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.srfkey')
    onSrfkeyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfkey', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfmajortext 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.srfmajortext')
    onSrfmajortextChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfmajortext', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srftempmode 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.srftempmode')
    onSrftempmodeChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srftempmode', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfuf 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.srfuf')
    onSrfufChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfuf', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfdeid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.srfdeid')
    onSrfdeidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfdeid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfsourcekey 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.srfsourcekey')
    onSrfsourcekeyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfsourcekey', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 equipcode 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.equipcode')
    onEquipcodeChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'equipcode', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 emequipname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.emequipname')
    onEmequipnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'emequipname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 equippname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.equippname')
    onEquippnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'equippname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 eqtypename 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.eqtypename')
    onEqtypenameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'eqtypename', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 eqlocationname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.eqlocationname')
    onEqlocationnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'eqlocationname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 deptname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.deptname')
    onDeptnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'deptname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 empname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.empname')
    onEmpnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'empname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 rteamname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.rteamname')
    onRteamnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'rteamname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 equipgroup 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.equipgroup')
    onEquipgroupChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'equipgroup', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 params 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.params')
    onParamsChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'params', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 eqstate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.eqstate')
    onEqstateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'eqstate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 eqisservice 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.eqisservice')
    onEqisserviceChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'eqisservice', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 eqstartdate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.eqstartdate')
    onEqstartdateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'eqstartdate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 eqsumstoptime 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.eqsumstoptime')
    onEqsumstoptimeChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'eqsumstoptime', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 haltstate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.haltstate')
    onHaltstateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'haltstate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 haltcause 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.haltcause')
    onHaltcauseChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'haltcause', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 empid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.empid')
    onEmpidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'empid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 deptid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.deptid')
    onDeptidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'deptid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 eqlocationid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.eqlocationid')
    onEqlocationidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'eqlocationid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 emequipid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.emequipid')
    onEmequipidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'emequipid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 equippid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.equippid')
    onEquippidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'equippid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 rteamid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.rteamid')
    onRteamidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'rteamid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 eqtypeid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main4
     */
    @Watch('data.eqtypeid')
    onEqtypeidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'eqtypeid', newVal: newVal, oldVal: oldVal });
    }


    /**
     * 重置表单项值
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @memberof Main4
     */
    public resetFormData({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
    }

    /**
      * 置空对象
      *
      * @param {any[]} args
      * @memberof EditForm
      */
    public ResetData(_datas:any){
        if(Object.keys(_datas).length >0){
            Object.keys(_datas).forEach((name: string) => {
                if (this.data.hasOwnProperty(name)) {
                    this.data[name] = null;
                }
            });
        }
    }

    /**
     * 表单逻辑
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @memberof Main4
     */
    public formLogic({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
                



































    }

    /**
     * 表单值变化
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @returns {void}
     * @memberof Main4
     */
    public formDataChange({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
        if (this.ignorefieldvaluechange) {
            return;
        }
        this.resetFormData({ name: name, newVal: newVal, oldVal: oldVal });
        this.formLogic({ name: name, newVal: newVal, oldVal: oldVal });
        this.dataChang.next(JSON.stringify(this.data));
    }

    /**
     * 表单加载完成
     *
     * @public
     * @param {*} [data={}]
     * @param {string} [action]
     * @memberof Main4
     */
    public onFormLoad(data: any = {},action:string): void {
        if(Object.is(action,"save") || Object.is(action,"autoSave") || Object.is(action,"submit"))
        // 更新context的实体主键
        if(data.emequip){
            Object.assign(this.context,{emequip:data.emequip})
        }
        this.setFormEnableCond(data);
        this.fillForm(data,action);
        this.oldData = {};
        Object.assign(this.oldData, JSON.parse(JSON.stringify(this.data)));
        this.$store.commit('viewaction/setViewDataChange', { viewtag: this.viewtag, viewdatachange: false });
        this.formLogic({ name: '', newVal: null, oldVal: null });
    }

    /**
     * 值填充
     *
     * @param {*} [_datas={}]
     * @param {string} [action]
     * @memberof Main4
     */
    public fillForm(_datas: any = {},action:string): void {
        this.ignorefieldvaluechange = true;
        Object.keys(_datas).forEach((name: string) => {
            if (this.data.hasOwnProperty(name)) {
                this.data[name] = _datas[name];
            }
        });
        if(Object.is(action,'loadDraft')){
            this.createDefault();
        }
        if(Object.is(action,'load')){
            this.updateDefault();
        }
        this.$nextTick(function () {
            this.ignorefieldvaluechange = false;
        })
    }

    /**
     * 设置表单项是否启用
     *
     * @public
     * @param {*} data
     * @memberof Main4
     */
    public setFormEnableCond(data: any): void {
        Object.values(this.detailsModel).forEach((detail: any) => {
            if (!Object.is(detail.detailType, 'FORMITEM')) {
                return;
            }
            const formItem: FormItemModel = detail;
            formItem.setEnableCond(data.srfuf);
        });
    }

    /**
     * 重置草稿表单状态
     *
     * @public
     * @memberof Main4
     */
    public resetDraftFormStates(): void {
        const form: any = this.$refs.form;
        if (form) {
            form.resetFields();
        }
    }

    /**
     * 重置校验结果
     *
     * @memberof Main4
     */
    public resetValidates(): void {
        Object.values(this.detailsModel).forEach((detail: any) => {
            if (!Object.is(detail.detailType, 'FORMITEM')) {
                return;
            }
            const formItem: FormItemModel = detail;
            formItem.setError('');
        });
    }

    /**
     * 填充校验结果 （后台）
     *
     * @param {any[]} fieldErrors
     * @memberof Main4
     */
    public fillValidates(fieldErrors: any[]): void {
        fieldErrors.forEach((error: any) => {
            const formItem: FormItemModel = this.detailsModel[error.field];
            if (!formItem) {
                return;
            }
            this.$nextTick(() => {
                formItem.setError(error.message);
            });
        });
    }

    /**
     * 表单校验状态
     *
     * @returns {boolean} 
     * @memberof Main4
     */
    public formValidateStatus(): boolean {
        const form: any = this.$refs.form;
        let validatestate: boolean = true;
        form.validate((valid: boolean) => {
            validatestate = valid ? true : false;
        });
        return validatestate
    }

    /**
     * 获取全部值
     *
     * @returns {*}
     * @memberof Main4
     */
    public getValues(): any {
        return this.data;
    }

    /**
     * 表单项值变更
     *
     * @param {{ name: string, value: any }} $event
     * @returns {void}
     * @memberof Main4
     */
    public onFormItemValueChange($event: { name: string, value: any }): void {
        if (!$event) {
            return;
        }
        if (!$event.name || Object.is($event.name, '') || !this.data.hasOwnProperty($event.name)) {
            return;
        }
        this.data[$event.name] = $event.value;
    }

    /**
     * 设置数据项值
     *
     * @param {string} name
     * @param {*} value
     * @returns {void}
     * @memberof Main4
     */
    public setDataItemValue(name: string, value: any): void {
        if (!name || Object.is(name, '') || !this.data.hasOwnProperty(name)) {
            return;
        }
        if (Object.is(this.data[name], value)) {
            return;
        }
        this.data[name] = value;
    }



    /**
     * 分组界面行为事件
     *
     * @param {*} $event
     * @memberof Main4
     */
    public groupUIActionClick($event: any): void {
        if (!$event) {
            return;
        }
        const item:any = $event.item;
    }

    /**
     * Vue声明周期(处理组件的输入属性)
     *
     * @memberof Main4
     */
    public created(): void {
        this.afterCreated();
    }

    /**
     * 执行created后的逻辑
     *
     *  @memberof Main4
     */    
    public afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
                if (Object.is('autoload', action)) {
                    this.autoLoad(data);
                }
                if (Object.is('load', action)) {
                    this.load(data);
                }
                if (Object.is('loaddraft', action)) {
                    this.loadDraft(data);
                }
                if (Object.is('save', action)) {
                    this.save(data,data.showResultInfo);
                }
                if (Object.is('remove', action)) {
                    this.remove(data);
                }
                if (Object.is('saveandexit', action)) {
                    this.saveAndExit(data);
                }
                if (Object.is('saveandnew', action)) {
                    this.saveAndNew(data);
                }
                if (Object.is('removeandexit', action)) {
                    this.removeAndExit(data);
                }
                if (Object.is('refresh', action)) {
                    this.refresh(data);
                }
            });
        }
        this.dataChang
            .pipe(
                debounceTime(300),
                distinctUntilChanged()
            ).subscribe((data: any) => {
                if (this.autosave) {
                    this.autoSave();
                }
                const state = !Object.is(JSON.stringify(this.oldData), JSON.stringify(this.data)) ? true : false;
                this.$store.commit('viewaction/setViewDataChange', { viewtag: this.viewtag, viewdatachange: state });
            });
    }

    /**
     * vue 生命周期
     *
     * @memberof Main4
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof Main4
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        if (this.dataChangEvent) {
            this.dataChangEvent.unsubscribe();
        }
    }

    /**
     * 拷贝内容
     *
     * @param {*} [arg={}]
     * @memberof @memberof Main4
     */
    public copy(arg: any = {}): void {
        this.loadDraft(arg);
    }

    /**
     *打印
     *@memberof @memberof Main4
     */
    public print(){
        let _this:any = this;
        _this.$print({id:'form',popTitle:'设备<主编辑>'});
    }

    /**
     * 部件刷新
     *
     * @param {any[]} args
     * @memberof Main4
     */
    public refresh(args: any[]): void {
        let arg: any = {};
        Object.assign(arg,args[0]);
        if (this.data.srfkey && !Object.is(this.data.srfkey, '')) {
            Object.assign(arg, { srfkey: this.data.srfkey });
            this.load(arg);
            return;
        }
        if (this.data.srfkeys && !Object.is(this.data.srfkeys, '')) {
            Object.assign(arg, { srfkey: this.data.srfkeys });
            this.load(arg);
            return;
        }
    }

    /**
     * 自动加载
     *
     * @param {*} [arg={}]
     * @returns {void}
     * @memberof Main4
     */
    public autoLoad(arg: any = {}): void {
        if (arg.srfkey && !Object.is(arg.srfkey, '')) {
            Object.assign(arg, { srfkey: arg.srfkey });
            this.load(arg);
            return;
        }
        if (arg.srfkeys && !Object.is(arg.srfkeys, '')) {
            Object.assign(arg, { srfkey: arg.srfkeys });
            this.load(arg);
            return;
        }
        this.loadDraft(arg);
    }

    /**
     * 加载
     *
     * @public
     * @param {*} [opt={}]
     * @memberof Main4
     */
    public load(opt: any = {}): void {
        if(!this.loadAction){
            this.$Notice.error({ title: '错误', desc: 'EMEQUIPEditView_EditMode视图表单loadAction参数未配置' });
            return;
        }
        const arg: any = { ...opt };
        let viewparamResult:any = Object.assign(arg,this.viewparams);
        const get: Promise<any> = this.service.get(this.loadAction,JSON.parse(JSON.stringify(this.context)),{viewparams:viewparamResult}, this.showBusyIndicator);
        get.then((response: any) => {
            if (response && response.status === 200) {
                const data = response.data;
                this.onFormLoad(data,'load');
                this.$emit('load', data);
                this.$nextTick(() => {
                    this.formState.next({ type: 'load', data: data });
                });
            }
        }).catch((response: any) => {
            if (response && response.status && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 加载草稿
     *
     * @param {*} [opt={}]
     * @memberof Main4
     */
    public loadDraft(opt: any = {}): void {
        if(!this.loaddraftAction){
            this.$Notice.error({ title: '错误', desc: 'EMEQUIPEditView_EditMode视图表单loaddraftAction参数未配置' });
            return;
        }
        const arg: any = { ...opt } ;
        let viewparamResult:any = Object.assign(arg,this.viewparams);
        let post: Promise<any> = this.service.loadDraft(this.loaddraftAction,JSON.parse(JSON.stringify(this.context)),{viewparams:viewparamResult}, this.showBusyIndicator);
        post.then((response: any) => {
            if (!response.status || response.status !== 200) {
                if (response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                }
                return;
            }

            const data = response.data;
            if(data.emequip){
                Object.assign(this.context,{emequip:data.emequip})
            }
            this.resetDraftFormStates();
            this.onFormLoad(data,'loadDraft');
            this.$emit('load', data);
            this.$nextTick(() => {
                this.formState.next({ type: 'load', data: data });
            });
            setTimeout(() => {
                const form: any = this.$refs.form;
                if (form) {
                    form.fields.forEach((field: any) => {
                        field.validateMessage = "";
                        field.validateState = "";
                        field.validateStatus = false;
                    });
                }
            });
        }).catch((response: any) => {
            if (response && response.status  && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 自动保存
     *
     * @param {*} [opt={}]
     * @memberof Main4
     */
    public autoSave(opt: any = {}): void {
        if (!this.formValidateStatus()) {
            return;
        }
        const arg: any = { ...opt };
        const data = this.getValues();
        Object.assign(arg, data);
        const action: any = Object.is(data.srfuf, '1') ? this.updateAction : this.createAction;
        if(!action){
            let actionName:any = Object.is(data.srfuf, '1')?"updateAction":"createAction";
            this.$Notice.error({ title: '错误', desc: 'EMEQUIPEditView_EditMode视图表单'+actionName+'参数未配置' });
            return;
        }
        Object.assign(arg,{viewparams:this.viewparams});
        const post: Promise<any> = this.service.add(action, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator);
        post.then((response: any) => {
            if (!response.status || response.status !== 200) {
                if (response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                }
                return;
            }

            const data = response.data;
            this.onFormLoad(data,'autoSave');
            this.$emit('save', data);
            this.$store.dispatch('viewaction/datasaved', { viewtag: this.viewtag });
            this.$nextTick(() => {
                this.formState.next({ type: 'save', data: data });
            });
        }).catch((response: any) => {
            if (response && response.status && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 保存
     *
     * @param {*} [opt={}]
     * @param {boolean} [showResultInfo] 
     * @param {boolean} [ifStateNext] formState是否下发通知
     * @returns {Promise<any>}
     * @memberof Main4
     */
    public async save(opt: any = {}, showResultInfo?: boolean, ifStateNext: boolean = true): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            showResultInfo = showResultInfo === undefined ? true : false;
            if (!this.formValidateStatus()) {
                this.$Notice.error({ title: '错误', desc: '值规则校验异常' });
                return;
            }
            const arg: any = { ...opt };
            const data = this.getValues();
            Object.assign(arg, data);
            Object.assign(arg, this.context);
            if (ifStateNext) {
                this.drcounter = 0;
                if(this.drcounter !== 0){
                    this.drsaveopt = opt;
                    this.formState.next({ type: 'beforesave', data: arg });//先通知关系界面保存
                    this.saveState = resolve;
                    return;
                }
            }
            const action: any = Object.is(data.srfuf, '1') ? this.updateAction : this.createAction;
            if(!action){
                let actionName:any = Object.is(data.srfuf, '1')?"updateAction":"createAction";
                this.$Notice.error({ title: '错误', desc: 'EMEQUIPEditView_EditMode视图表单'+actionName+'参数未配置' });
                return;
            }
            Object.assign(arg,{viewparams:this.viewparams});
            const post: Promise<any> = Object.is(data.srfuf, '1')?this.service.update(action, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator):this.service.add(action,JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator);
            post.then((response: any) => {
                if (!response.status || response.status !== 200) {
                    if (response.data) {
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                    }
                    return;
                }

                const data = response.data;
                this.onFormLoad(data,'save');
                this.$emit('save', data);
                this.$store.dispatch('viewaction/datasaved', { viewtag: this.viewtag });
                this.$nextTick(() => {
                    this.formState.next({ type: 'save', data: data });
                });
                if (showResultInfo) {
                    this.$Notice.success({ title: '', desc: (data.srfmajortext ? data.srfmajortext : '') + '&nbsp;保存成功！' });
                }
                resolve(response);
            }).catch((response: any) => {
                if (response && response.status  && response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                    reject(response);
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    reject(response);
                    return;
                }
                reject(response);
            });
        })
    }

    /**
    * 删除
    *
    * @public
    * @param {*} [opt={}]
    * @memberof EditForm
    */
    public remove(opt:Array<any> = [],showResultInfo?: boolean): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            if(!this.removeAction){
                this.$Notice.error({ title: '错误', desc: 'EMEQUIPEditView_EditMode视图表单removeAction参数未配置' });
                return;
            }
            const arg: any = opt[0];
            const _this: any = this;
            Object.assign(arg,{viewparams:this.viewparams});
            this.service.delete(_this.removeAction, JSON.parse(JSON.stringify(this.context)),arg, showResultInfo).then((response: any) => {
                if (response) {
                    const data = response.data;
                    this.$emit('remove',data);
                    this.formState.next({ type: 'remove', data: data });
                    this.data.ismodify = false;
                    this.$Notice.success({ title: '', desc: (data.srfmajortext ? data.srfmajortext : '') + '&nbsp;删除成功！' });
                    resolve(response);
                }
            }).catch((error: any) => {
                const { data: _data } = error;
                this.$Notice.error({ title: _data.title, desc: _data.message });
                reject(error);
            });
        });
    }

    /**
     * 工作流启动
     *
     * @param {*} [data={}]
     * @param {*} [localdata={}]
     * @returns {Promise<any>}
     * @memberof Main4
     */
    public async wfstart(data: any,localdata?:any): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            const _this: any = this;
            const post: Promise<any> = _this.save({},false);
            post.then((response:any) =>{
                const arg:any = response.data;
                if(this.viewparams){
                    Object.assign(arg,{viewparams:this.viewparams});
                }
                const result: Promise<any> = this.service.wfstart(_this.WFStartAction, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator,localdata);
                result.then((response: any) => {
                    if (!response || response.status !== 200) {
                        if(response.data){
                            this.$Notice.error({ title: '', desc: '工作流启动失败, ' + response.data.message });
                        }
                        return;
                    }
                    this.$Notice.info({ title: '', desc: '工作流启动成功' });
                    resolve(response);
            }).catch((response: any) => {
                if (response && response.status && response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                    reject(response);
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    reject(response);
                    return;
                }
                reject(response);
            });
            }).catch((response: any) => {
                    if (response && response.status && response.data) {
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                        reject(response);
                        return;
                    }
                    if (!response || !response.status || !response.data) {
                        this.$Notice.error({ title: '错误', desc: '系统异常' });
                        reject(response);
                        return;
                    }
                    reject(response);
            })
        });
    }

    /**
     * 工作流提交
     *
     * @param {*} [data={}]
     * @param {*} [localdata={}]
     * @returns {Promise<any>}
     * @memberof Main4
     */
    public async wfsubmit(data: any,localdata?:any): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
        const _this: any = this;
        const arg: any = data[0];
        Object.assign(arg,{viewparams:this.viewparams});
        if (!arg.emequip || Object.is(arg.emequip, '')) {
            return;
        }
        const post: Promise<any> = Object.is(arg.srfuf, '1')?this.service.update(this.updateAction, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator):this.service.add(this.createAction,JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator);
        post.then((response:any) =>{
                const arg:any = response.data;
                // 保存完成UI处理
                this.onFormLoad(arg,'save');
                this.$emit('save', arg);
                this.$nextTick(() => {
                    this.formState.next({ type: 'save', data: arg });
                });
                // 准备提交参数
                if(this.viewparams){
                    Object.assign(arg,{viewparams:this.viewparams});
                }
                const result: Promise<any> = this.service.wfsubmit(_this.WFSubmitAction, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator,localdata);
                result.then((response: any) => {
                    if (!response || response.status !== 200) {
                        if(response.data){
                            this.$Notice.error({ title: '', desc: '工作流提交失败, ' + response.data.message });
                        }
                        return;
                    }
                    this.onFormLoad(arg,'submit');
                    this.$store.dispatch('viewaction/datasaved', { viewtag: this.viewtag });
                    this.$Notice.info({ title: '', desc: '工作流提交成功' });
                    resolve(response);
            }).catch((response: any) => {
                if (response && response.status && response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                    reject(response);
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    reject(response);
                    return;
                }
                reject(response);
            });
            }).catch((response: any) => {
                    if (response && response.status && response.data) {
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                        reject(response);
                        return;
                    }
                    if (!response || !response.status || !response.data) {
                        this.$Notice.error({ title: '错误', desc: '系统异常' });
                        reject(response);
                        return;
                    }
                    reject(response);
            })
        })
    }

    /**
     * 表单项更新
     *
     * @param {string} mode 界面行为名称
     * @param {*} [data={}] 请求数据
     * @param {string[]} updateDetails 更新项
     * @param {boolean} [showloading] 是否显示加载状态
     * @returns {void}
     * @memberof Main4
     */
    public updateFormItems(mode: string, data: any = {}, updateDetails: string[], showloading?: boolean): void {
        if (!mode || (mode && Object.is(mode, ''))) {
            return;
        }
        const arg: any = { ...data };
        Object.assign(arg,this.viewparams);
        const post: Promise<any> = this.service.frontLogic(mode,JSON.parse(JSON.stringify(this.context)),arg, showloading);
        post.then((response: any) => {
            if (!response || response.status !== 200) {
                this.$Notice.error({ title: '错误', desc: '表单项更新失败' });
                return;
            }
            const data = response.data;
            const _data: any = {};
            updateDetails.forEach((name: string) => {
                if (!data.hasOwnProperty(name)) {
                    return;
                }
                Object.assign(_data, { [name]: data[name] });
            });
            this.setFormEnableCond(_data);
            this.fillForm(_data,'updateFormItem');
            this.formLogic({ name: '', newVal: null, oldVal: null });
            this.dataChang.next(JSON.stringify(this.data));
            this.$nextTick(() => {
                this.formState.next({ type: 'updateformitem', ufimode: arg.srfufimode, data: _data });
            });
        }).catch((response: any) => {
            if (response && response.status && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 回车事件
     *
     * @param {*} $event
     * @memberof Main4
     */
    public onEnter($event: any): void {
    }

    /**
     * 保存并退出
     *
     * @param {any[]} args
     * @memberof Main4
     */
    public saveAndExit(data:any[]):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            if(data && data.length > 0){
                Object.assign(arg,data[0]);
            }
            _this.currentAction = "saveAndExit";
            _this.save([arg]).then((res) =>{
                if(res){
                    _this.closeView(res.data);
                }
                resolve(res);
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
     * 保存并新建
     *
     * @param {any[]} args
     * @memberof Main4
     */
    public saveAndNew(data:any[]):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            if(data && data.length > 0){
                Object.assign(arg,data[0]);
            }
            _this.currentAction = "saveAndNew";
            _this.save([arg]).then((res) =>{
                _this.ResetData(res);
                _this.loadDraft({});
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
     * 删除并退出
     *
     * @param {any[]} args
     * @memberof Main4
     */
    public removeAndExit(data:any[]):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            if(data && data.length > 0){
                Object.assign(arg,data[0]);
            }
            _this.remove([arg]).then((res) =>{
                if(res){
                  _this.closeView(res.data);
                }
                resolve(res);
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
    * 关系界面数据保存完成
    *
    * @param {any} $event
    * @memberof Main4
    */
    public drdatasaved($event:any){
        let _this = this;
        this.drcounter--;
        if(this.drcounter > 0){
            return;
        }
        this.save(this.drsaveopt, undefined, false).then((res) =>{
            this.saveState(res);
            this.drsaveopt = {};
            if(Object.is(_this.currentAction, "saveAndNew")){
                _this.ResetData(res);
                _this.loadDraft({});
            }else if(Object.is(_this.currentAction, "saveAndExit")){
                if(res){
                    _this.closeView(res.data);
                }
            }
        });
    }

    /**
     * 新建默认值
     * @memberof Main4
     */
    public createDefault(){                    
    }

    /**
     * 更新默认值
     * @memberof Main4
     */
    public updateDefault(){                    
    }

    
}
</script>

<style lang='less'>
@import './main4-form.less';
</style>